# PMI_RANK is set by the Intel MPI environment
# The syntax of KMP_PLACE_THREADS is <cores>Cx<threads>T,<coreoffset>O (see examples below)
# but with lot of variants e.g. 3Cx2T,0O == 3cX2t,0O == 3x2x0 == 3,2,0 ... (see compiler docs)
placethreads=$1	# <cores>Cx<threads>T
if [ "$placethreads" ]; then
  cores=`echo $placethreads|sed 's/[cCxX,].*//'`
  export KMP_PLACE_THREADS=${placethreads},$((cores*PMI_RANK))O
else
# export KMP_PLACE_THREADS=4Cx4T,$((4*PMI_RANK))O
# export KMP_PLACE_THREADS=4Cx1T,$((4*PMI_RANK))O
# export KMP_PLACE_THREADS=2Cx4T,$((2*PMI_RANK))O
# export KMP_PLACE_THREADS=2Cx2T,$((2*PMI_RANK))O
  export KMP_PLACE_THREADS=1Cx4T,$((1*PMI_RANK))O
fi
echo MPI rank ${PMI_RANK} with offload threads bound by KMP_PLACE_THREADS=$KMP_PLACE_THREADS
./test-offload
