#define CHUNK_SIZE  8192

int body_start_index;
for(body_start_index = 0; body_start_index < global_number_of_bodies; body_start_index += CHUNK_SIZE)
{
    int i;
    int body_end_index = body_start_index + CHUNK_SIZE;

#   pragma omp parallel for private(i) schedule(guided)
    for(i=starting_index; i<ending_index; i++) 
    {
        int j;
        TYPE acc_x_0 = 0, acc_y_0 = 0, acc_z_0 = 0;

#       pragma omp simd reduction(+:acc_x_0,acc_y_0,acc_z_0) 
        for(j=body_start_index; j<body_end_index; j+=1) {
                __assume_aligned(Input_Position_X,64);
                __assume_aligned(Input_Position_Y,64);
                __assume_aligned(Input_Position_Z,64);
                __assume_aligned(Mass,64);
                TYPE delta_x_0 = Input_Position_X[(j+0)] - Input_Position_X[i];
                TYPE delta_y_0 = Input_Position_Y[(j+0)] - Input_Position_Y[i];
                TYPE delta_z_0 = Input_Position_Z[(j+0)] - Input_Position_Z[i];

                TYPE gamma_0 = delta_x_0*delta_x_0 + delta_y_0*delta_y_0 + delta_z_0*delta_z_0 + epsilon_sqr;
                TYPE s_0 = Mass[j+0]/(gamma_0 * SQRT(gamma_0));
                acc_x_0 += s_0*delta_x_0;
                acc_y_0 += s_0*delta_y_0;
                acc_z_0 += s_0*delta_z_0;
        }

        Output_Acceleration[3*(i+0)+0] += acc_x_0;
        Output_Acceleration[3*(i+0)+1] += acc_y_0;
        Output_Acceleration[3*(i+0)+2] += acc_z_0;
    }
}
